gstreamermm: Gst::EventStep Class Reference

gstreamermm 1.10.0

Public Member Functions | Static Public Member Functions | List of all members
Gst::EventStep Class Reference

A step event. More...

`#include <gstreamermm/event.h>`

Inheritance diagram for Gst::EventStep:
[legend]

## Public Member Functions
void | parse (Gst::Format& format, guint64& amount, double& rate, bool&flush, bool& intermediate) const
| Parse the step event. More...
guint64 | parse_amount () const
| Get the amount in a step event. More...
Gst::Format | parse_format () const
| Get the format in a step event. More...
double | parse_rate () const
| Get the rate in a step event. More...
bool | parse_flush () const
| Get the flush in a step event. More...
bool | parse_intermediate () const
| Get the intermediate flag in a step event. More...
Public Member Functions inherited from Gst::Event
void | reference () const
| Increment the reference count for this object. More...
void | unreference () const
| Decrement the reference count for this object. More...
GstEvent* | gobj ()
| Provides access to the underlying C instance. More...
const GstEvent* | gobj () const
| Provides access to the underlying C instance. More...
GstEvent* | gobj_copy () const
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
| Event ()=delete
| Event (const Event&)=delete
Event& | operator= (const Event&)=delete
Gst::Structure | get_structure () const
| Access the structure of the event. More...
bool | has_name (const Glib::ustring& name) const
| Checks if event has the given name. More...
guint32 | get_seqnum () const
| Retrieve the sequence number of a event. More...
void | set_seqnum (guint32 seqnum)
| Set the sequence number of a event. More...
gint64 | get_running_time_offset () const
| Retrieve the accumulated running time offset of the event. More...
void | set_running_time_offset (gint64 offset)
| Set the running time offset of a event. More...
Glib::RefPtr< Gst::Event > | copy () const
| Copy the event using the event specific copy function. More...
Glib::RefPtr< Gst::Event > | create_writable ()
| Makes a writable event from the given event. More...
bool | is_downstream () const
| Check if an event can travel downstream. More...
bool | is_serialized () const
| Check if an event is serialized with the data stream. More...
bool | is_upstream () const
| Check if an event can travel upstream. More...
EventType | get_event_type () const
| Get the Gst::EventType of the event. More...
Gst::ClockTime | get_timestamp () const
| Get the Gst::ClockTime timestamp of the event. More...
Public Member Functions inherited from Gst::MiniObject
void | reference () const
| Increment the reference count for this object. More...
void | unreference () const
| Decrement the reference count for this object. More...
GstMiniObject* | gobj ()
| Provides access to the underlying C instance. More...
const GstMiniObject* | gobj () const
| Provides access to the underlying C instance. More...
GstMiniObject* | gobj_copy () const
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
| MiniObject ()=delete
| MiniObject (const MiniObject&)=delete
MiniObject& | operator= (const MiniObject&)=delete
| ~MiniObject ()
guint | get_flags () const
void | set_flags (const guint& value)
gint | get_refcount () const
gint | get_lockstate () const
bool | lock (LockFlags flags)
| Lock the mini-object with the specified access mode in flags. More...
void | unlock (LockFlags flags)
| Unlock the mini-object with the specified access mode in flags. More...
bool | is_writable () const
| If mini_object has the LOCKABLE flag set, check if the current EXCLUSIVE lock on object is the only one, this means that changes to the object will not be visible to any other object. More...
Glib::RefPtr< MiniObject > | create_writable ()
| Checks if a mini-object is writable. More...
void | set_qdata (GQuark quark, QuarkData* data)
| This sets an opaque, named pointer on a miniobject. More...
QuarkData* | get_qdata (GQuark quark) const
| This function gets back user data pointers stored via set_qdata(). More...
QuarkData* | steal_qdata (GQuark quark)
| This function gets back user data pointers stored via set_qdata() and removes the data from object without invoking its destroy() function (if any was set). More...
void | add_finalize_notifier (const SlotFinalizer& slot)
| Adds notifier when mini object is finalized. More...
void | remove_finalize_notifier ()
| Remove finalize notifier. More...

## Static Public Member Functions
static Glib::RefPtr< Gst::EventStep > | create (Gst::Format format, guint64 amount, double rate, bool flush, bool intermediate)
| Create a new step event. More...

## Additional Inherited Members
Public Types inherited from Gst::MiniObject
typedef sigc::slot< void > | SlotFinalizer
Protected Member Functions inherited from Gst::Event
void | operator delete (void*, std::size_t)
Protected Member Functions inherited from Gst::MiniObject
void | operator delete (void*, std::size_t)
Related Functions inherited from Gst::Event
Glib::RefPtr< Gst::Event > | wrap (GstEvent* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::MiniObject
Glib::RefPtr< Gst::MiniObject > | wrap (GstMiniObject* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

A step event.

See create() for more details.

## Member Function Documentation

## ◆ create()

static Glib::RefPtr<Gst::EventStep> Gst::EventStep::create | ( | Gst::Format | format,
|  | guint64 | amount,
|  | double | rate,
|  | bool | flush,
|  | bool | intermediate
| ) |  |
| static

Create a new step event.

The purpose of the step event is to instruct a sink to skip amount (expressed in format) of media. It can be used to implement stepping through the video frame by frame or for doing fast trick modes.

A rate of <= 0.0 is not allowed. Pause the pipeline, for the effect of rate = 0.0 or first reverse the direction of playback using a seek event to get the same effect as rate < 0.0.

The flush flag will clear any pending data in the pipeline before starting the step operation.

The intermediate flag instructs the pipeline that this step operation is part of a larger step operation.

Parameters

  format | The format of amount.
  amount | The amount of data to step.
  rate | The step rate.
  flush | Flushing steps.
  intermediate | Intermediate steps.

Returns
  A new Gst::Event.

## ◆ parse()

void Gst::EventStep::parse | ( | Gst::Format& | format,
|  | guint64 & | amount,
|  | double & | rate,
|  | bool & | flush,
|  | bool & | intermediate
| ) |  | const

Parse the step event.

Parameters

  format | A reference to store the format in.
  amount | A reference to store the amount in.
  rate | A reference to store the rate in.
  flush | A reference to store the flush boolean in.
  intermediate | A reference to store the intermediate boolean in.

## ◆ parse_amount()

guint64 Gst::EventStep::parse_amount | ( |  | ) | const

Get the amount in a step event.

Returns
  The amount.

## ◆ parse_flush()

bool Gst::EventStep::parse_flush | ( |  | ) | const

Get the flush in a step event.

Returns
  The flush flag.

## ◆ parse_format()

Gst::Format Gst::EventStep::parse_format | ( |  | ) | const

Get the format in a step event.

Returns
  The format.

## ◆ parse_intermediate()

bool Gst::EventStep::parse_intermediate | ( |  | ) | const

Get the intermediate flag in a step event.

Returns
  The intermediate flag.

## ◆ parse_rate()

double Gst::EventStep::parse_rate | ( |  | ) | const

Get the rate in a step event.

Returns
  The rate.